﻿// TRANSLATED FROM PAPER.JS examples/Animated/RoundedRectangles.html
package
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Rounder extends Sprite
	{
		private var colors:Array = new Array(0x000000,0xffffff,0x000000,0xffffff);
		private var angle:uint = 5;
		public function Rounder()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);	
		}
		private function addedHandler(e:Event):void
		{
			for(var i:Number = 0;i<100;i++){
				var rect:Shape = new Shape();
				rect.graphics.beginFill(colors[i%2]);
				rect.graphics.drawCircle(20,20,20);
				rect.graphics.endFill();
				rect.scaleX = rect.scaleY = (1-i/25)*40;
				addChild(rect);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			var i:uint = 0;
			while(i<numChildren)
			{
				var rect:Shape = getChildAt(i) as Shape;
				var distPoint:Point = new Point((rect.x-mouseY)/(i + 10),(rect.y-mouseX)/(i + 5));
				var distance:Number = Math.sqrt(distPoint.x*distPoint.x + distPoint.y*distPoint.y);
				rect.rotation = Math.sin((angle+i)/20)*80;
				if(distance>0.1){
					rect.x-=distPoint.x;
					rect.y-=distPoint.y;
				}
				i++;
			}
			angle++;
		}
	}
}